<template>
<div @click="onWrapperClick">
  <button :class="buttonClass">
    {{ buttonValue }}
  </button>
</div>
</template>

<script>
export default {
  name: 'AuthButton',
  props: {
    buttonType: {
      type: String,
      required: true,
      validator(value) {
        return [
          'google',
          'twitter',
          'facebook',
          'login',
          'signup',
        ].indexOf(value) !== -1;
      },
    },
    buttonValue: {
      type: String,
      default: '',
      required: false,
    },
    isDisabled: {
      type: Boolean,
      default: false,
      required: false,
    },
  },
  computed: {
    buttonClass() {
      return {
        base: true,
        disabled: this.isDisabled,
        google: this.buttonType === 'google',
        twitter: this.buttonType === 'twitter',
        facebook: this.buttonType === 'facebook',
        login: this.buttonType === 'login',
        signup: this.buttonType === 'signup',
      };
    },
  },
  methods: {
    onWrapperClick() {
      if (!this.isDisabled) {
        this.$emit('click');
      }
    },
  },
};
</script>

<style lang="scss" scoped>
@import '~styles/colors.scss';

.base {
  width: 280px;
  margin: 0.5em 0;
  padding: 0.875em 1.25em;

  border-radius: 0.5em;
  border: none;
  box-shadow:  rgba(0, 0, 0, 0.3) 0px 1px 2px;

  font-weight: 600;
  font-size: inherit;
  color: white;

  transition: 0.2s;
}

.base:hover {
  cursor: pointer;
}

.base:focus {
  outline: transparent;
}

/* <Disabled button> */
.disabled {
  cursor: not-allowed !important;
  opacity: 0.5;
}
/* </Disabled button> */

/* <Google Login> */
.google {
  color: rgb(51, 51, 51);
  background-color: $button-auth-google;
}
/* </Google Login> */

/* <Twitter Login> */
.twitter {
  background-color: $button-auth-twitter;
}
/* </Twitter Login> */

/* <Facebook Login> */
.facebook {
  background-color: $button-auth-facebook;
}
/* </Facebook Login> */

/* <Log In Button> or <Sign Up Button> */
.login, .signup {
  background-color: $button-auth-login;
}
/* </Log In Button> or </Sign Up Button> */
</style>
